# need the helm-cli from the helm image
FROM openshift/ose-metering-helm:v4.5.0-202009161248.p0 AS helm
ENV __doozer=update BUILD_RELEASE=202009252146.p0 BUILD_VERSION=v4.5.0 OS_GIT_MAJOR=4 OS_GIT_MINOR=5 OS_GIT_PATCH=0 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.5.0-202009252146.p0 SOURCE_GIT_TREE_STATE=clean 
ENV __doozer=merge KUBE_GIT_COMMIT=73f0616fde62df418b73ce45651b48d07b1dd3e0 KUBE_GIT_MAJOR=1 KUBE_GIT_MINOR=16+ KUBE_GIT_TREE_STATE=clean KUBE_GIT_VERSION=v1.16.0+73f0616 OS_GIT_COMMIT=73f0616 OS_GIT_VERSION=4.5.0-202009252146.p0-73f0616 SOURCE_DATE_EPOCH=1601059584 SOURCE_GIT_COMMIT=73f0616fde62df418b73ce45651b48d07b1dd3e0 SOURCE_GIT_TAG=0.14.0-1172-g73f0616f SOURCE_GIT_URL=https://github.com/kube-reporting/metering-operator 
# final image needs kubectl, so we copy `oc` from cli image to use as kubectl.
FROM openshift/ose-cli:v4.5.0-202009161248.p0 AS cli
ENV __doozer=update BUILD_RELEASE=202009252146.p0 BUILD_VERSION=v4.5.0 OS_GIT_MAJOR=4 OS_GIT_MINOR=5 OS_GIT_PATCH=0 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.5.0-202009252146.p0 SOURCE_GIT_TREE_STATE=clean 
ENV __doozer=merge KUBE_GIT_COMMIT=73f0616fde62df418b73ce45651b48d07b1dd3e0 KUBE_GIT_MAJOR=1 KUBE_GIT_MINOR=16+ KUBE_GIT_TREE_STATE=clean KUBE_GIT_VERSION=v1.16.0+73f0616 OS_GIT_COMMIT=73f0616 OS_GIT_VERSION=4.5.0-202009252146.p0-73f0616 SOURCE_DATE_EPOCH=1601059584 SOURCE_GIT_COMMIT=73f0616fde62df418b73ce45651b48d07b1dd3e0 SOURCE_GIT_TAG=0.14.0-1172-g73f0616f SOURCE_GIT_URL=https://github.com/kube-reporting/metering-operator 
# real base
FROM openshift/ose-ansible-operator:v4.5.0-202009161248.p0
ENV __doozer=update BUILD_RELEASE=202009252146.p0 BUILD_VERSION=v4.5.0 OS_GIT_MAJOR=4 OS_GIT_MINOR=5 OS_GIT_PATCH=0 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.5.0-202009252146.p0 SOURCE_GIT_TREE_STATE=clean 
ENV __doozer=merge KUBE_GIT_COMMIT=73f0616fde62df418b73ce45651b48d07b1dd3e0 KUBE_GIT_MAJOR=1 KUBE_GIT_MINOR=16+ KUBE_GIT_TREE_STATE=clean KUBE_GIT_VERSION=v1.16.0+73f0616 OS_GIT_COMMIT=73f0616 OS_GIT_VERSION=4.5.0-202009252146.p0-73f0616 SOURCE_DATE_EPOCH=1601059584 SOURCE_GIT_COMMIT=73f0616fde62df418b73ce45651b48d07b1dd3e0 SOURCE_GIT_TAG=0.14.0-1172-g73f0616f SOURCE_GIT_URL=https://github.com/kube-reporting/metering-operator 

USER root
RUN set -x; \
    INSTALL_PKGS="curl bash ca-certificates \
    less which inotify-tools tini \
    python-netaddr python2-botocore \
    python2-boto3 python2-openshift \
    python2-cryptography ansible openssl" \
    && yum install --setopt=skip_missing_names_on_install=False -y $INSTALL_PKGS  \
    && yum clean all \
    && rm -rf /var/cache/yum

COPY --from=helm /usr/local/bin/helm /usr/local/bin/helm
COPY --from=cli /usr/bin/oc /usr/bin/oc
RUN ln -f -s /usr/bin/oc /usr/bin/kubectl

RUN yum -y update python2-openshift python2-cryptography

ENV HOME /opt/ansible
ENV HELM_CHART_PATH ${HOME}/charts/openshift-metering

COPY images/metering-ansible-operator/roles/ ${HOME}/roles/
COPY images/metering-ansible-operator/watches.yaml ${HOME}/watches.yaml
COPY images/metering-ansible-operator/scripts ${HOME}/scripts
COPY images/metering-ansible-operator/ansible.cfg /etc/ansible/ansible.cfg
COPY charts/openshift-metering ${HELM_CHART_PATH}

COPY manifests/deploy/openshift/olm/bundle /manifests

ENTRYPOINT ["tini", "--", "/usr/local/bin/ansible-operator", "exec-entrypoint", "ansible", "--watches-file", "/opt/ansible/watches.yaml"]

USER 1001

LABEL \
        io.k8s.display-name="OpenShift metering-ansible-operator" \
        io.k8s.description="This is a component of OpenShift Container Platform and manages installation and configuration of all other metering components." \
        summary="This is a component of OpenShift Container Platform and manages installation and configuration of all other metering components." \
        io.openshift.tags="openshift" \
        com.redhat.delivery.appregistry="false" \
        maintainer="<metering-team@redhat.com>" \
        name="openshift/ose-metering-ansible-operator" \
        com.redhat.component="ose-metering-ansible-operator-container" \
        io.openshift.maintainer.product="OpenShift Container Platform" \
        io.openshift.maintainer.component="Metering Operator" \
        release="202009252146.p0" \
        io.openshift.build.commit.id="73f0616fde62df418b73ce45651b48d07b1dd3e0" \
        io.openshift.build.source-location="https://github.com/kube-reporting/metering-operator" \
        io.openshift.build.commit.url="https://github.com/kube-reporting/metering-operator/commit/73f0616fde62df418b73ce45651b48d07b1dd3e0" \
        version="v4.5.0"

